Program TroisPos;

{ -----------------------------------------------------------------------------------------

Cette routine calcule connaissant 3 positions d'un satellite, dans J2000 (IJK pour la Terre)
par leurs coordonnes cartsiennes exprimes e km :
	La vitesse V1 au point 1 par ses composantes,
	Le paramtre p
	L'excentricit e
	Les vecteurs N, D, S de la thorie de Gibbs en km2
La constante de gravitation doit tre donne en km3s-2

{ -----------------------------------------------------------------------------------------}
      
uses constype,fonvect,wincrt;  


Var mu,r1,r2,r3,exc,par,k,precision:real;
    x1,x2,x3,v1,result1,result2,result3,n1,n2,n3,d,n,vect3,s,xn,xd:vecteur;
    ch:char;
    Test_mauvais:boolean;

Label retour_erreur;

Procedure Demande(Var x1,x2,x3:vecteur);

Begin
 {Demande des 3 vecteurs}
        Writeln('      Donnez les 3 composantes du vecteur 1 en km');
        Write('     x1[1]=');ReadLn(x1[1]);
        Write('     x1[2]=');ReadLn(x1[2]);
        Write('     x1[3]=');ReadLn(x1[3]);

        WriteLn('      Donnez les 3 composantes du vecteur 2 en km');
        Write('     x2[1]=');ReadLn(x2[1]);
        Write('     x2[2]=');ReadLn(x2[2]);
        Write('     x2[3]=');ReadLn(x2[3]);

	WriteLn('      Donnez les 3 composantes du vecteur 3 en km');
        Write('     x3[1]=');ReadLn(x3[1]);
        Write('     x3[2]=');ReadLn(x3[2]);
	Write('     x3[3]=');ReadLn(x3[3]);

        WriteLn('     La coplanarit vrifie/valeur du dterminant/unitaires des 3 vecteurs');
        Write('     Donnez la prcision de coplanarit choisie ( 1e-2 ou 1e-3 etc...)?');readLn(Precision);


End;

{ *******************************************************************}
Procedure verification_coplanaire;

Var Urayon1,Urayon2,Urayon3,result:vecteur;
    determinant:real;

Begin
   unitaire(x1,Urayon1); unitaire(x2,Urayon2);unitaire(x3,Urayon3);
   prodvect(Urayon1,Urayon2,result);
   determinant:=prodscal(result,x3);
   Test_mauvais:=false;


If Abs(determinant)>precision then
   Begin
     WriteLn('   ERREUR DE DONNEES OU DE PRECISION, CAR DETERMINANT DES VECTEURS NON NUL'); Test_mauvais:=true;
   End;

End;

{ ***************************************************************}


       BEGIN

       WriteLn('     Donnez la constante de gravitation Mu de l''astre, en km3s-2 ');
       Write('      Mu= ');  ReadLn(Mu);
RETOUR_ERREUR:
       Demande(x1,x2,x3);
       Verification_coplanaire;
       If test_mauvais then goto Retour_Erreur;

    
       WriteLn;
       WriteLn('   Appuyez une touche pour continuer');   Ch:=readkey;
       {Calcul du vecteur D }

         prodvect(x1,x2,result3);
         prodvect(x2,x3,result1);
         prodvect(x3,x1,result2);

         somme(result1,result2,vect3);
	 somme(result3,vect3,d);
       { Sortie D }
	 WriteLn('     Vecteur D');
         WriteLn('      D[1]= ',d[1]); WriteLn('      D[2]= ',d[2]);WriteLn('      D[3]= ',d[3]);
         WriteLn;
       {Calcul du vecteur N }

         r1:=norm(x1);
	 r2:=norm(x2);
         r3:=norm(x3);

	 scalvect(r1,result1,n1);
         scalvect(r2,result2,n2);
         scalvect(r3,result3,n3);

         somme(n1,n2,vect3);
	 somme(n3,vect3,n);
       { Sortie N}
         WriteLn('     Vecteur N');
	 WriteLn('      N[1]= ',n[1]); WriteLn('      N[2]= ',n[2]);WriteLn('      N[3]= ',n[3]);
          WriteLn;
        {Calcul du parametre p }
         scalvect(1e-10,d,xd);
         scalvect(1e-10,n,xn);
         par:=norm(xn)/norm(xd);

        {Calcul du vecteur s }

         scalvect(r2-r3,x1,result1);
         scalvect(r3-r1,x2,result2);
         scalvect(r1-r2,x3,result3);

         somme(result1,result2,vect3);
	 somme(result3,vect3,s);

        { Sortie S }
         WriteLn('     Vecteur S');
         WriteLn('      S[1]= ',s[1]); WriteLn('      S[2]= ',s[2]);WriteLn('      S[3]= ',s[3]);
          WriteLn;

         {Calcul du vecteur vitesse v1 correspondant a la position 1}

	 prodvect(xd,x1,result1);
         k:=sqrt(mu/norm(xn)/norm(xd))*1e-10;
         scalvect(k/norm(x1)*1e10,result1,result2);
         scalvect(k,s,result3);
         somme(result2,result3,v1);

	{ Sortie V1 }
	 WriteLn('     Vecteur V1');
	 WriteLn('      V1[1]= ',V1[1]); WriteLn('      V1[2]= ',v1[2]);WriteLn('      V1[3]= ',v1[3]);
	 WriteLn;

	 WriteLn('      Parametre p= ',par) ;

	 exc:=Norm(s)/norm(d);

	 Writeln('      Excentricite= ', exc);
	 WriteLn;

	 WriteLn('     Pour calculer les parametres orbitaux, utilisez ---> RV_PAR_W.exe');
	 Writeln;

     write('                     APPUYER SUR UNE TOUCHE POUR TERMINER');
     ch:=readkey;
     DoneWinCrt;

     END.

