UNIT GIOTTO;

{declaration des unites utilisees dans le programme principal}
                 INTERFACE

USES wincrt,constype,fonvect,fonscal,halleyjj,
     ephterjj,biposej,djj_norm;

PROCEDURE GIOTTO_OPTI(datejt,mjt,datejh,mjh:real;var c3:real;zo:real);
                                                   
                      IMPLEMENTATION                                            
{#########################################################################}

PROCEDURE GIOTTO_OPTI;
var 
    ra,va,rt,rst,vt,vitdepart,vitarrivee,vitinfT:vecteur;
    nvitinfT,Rspht,nrt,nvitr,norsp,nva,deltatd0,
    sterre,nsterre,convjt,parking,alpha,
    ro,duree,dureecalculee:real;
    param:tabparam;
    i,cas,jr,ms,an,hr,mn,sec:integer;

    
   
{***************************************************************************}


PROCEDURE VITESSEINFINIE(var vt,vitdepart,vitinfT:vecteur;var nvitinfT:real);

{cette procedure calcule les composantes et la normede la vitesse sonde/TERRE au depart }

BEGIN

  soustraction(vt,vitdepart,vitinfT);
 
  alpha := angvect(vt,vitdepart);

  nvitinfT := sqrt(sqr(norm(vitdepart))+sqr(norm(vt))-2*norm(vitdepart)*norm(vt)*cos(alpha));

    

END;
{***************************************************************************}

PROCEDURE CALCUL_RSPHERE_INF(var rt:vecteur;var nrt,Rsph:real;
mus,mut:real);

{cette procedure calcule le rayon de la sphere d'influence de la TERRE }



BEGIN
    nrt:=norm(rt);
    Rsph:=nrt*exp(ln((mut/mus))*(2/5));
    
END;
{***************************************************************************}

PROCEDURE HYPEVASION(var deltatd0,Rsph,convjt:real;mut,rterre,zo:real);
var aht,eht,ct,phit:real;

{cette procedure calcule le temps de montee sur l'hyperbole d'evasion
 a partir de la TERRE jusqu'a la limite de la sphere d'influence }


BEGIN

ro:=rterre+zo;

{calcul de a}
aht:=mut/(((nvitinfT)*(nvitinfT))-2*(mut/Rsph));

{calcul de l'excentricite}
eht:=(1+(ro/aht));

ct:=((1/eht)+(Rspht/(aht*eht)));
phit:=argch(ct);

{calcul du temps de transit sur l'hyperbole en jours}
deltatd0:=aht*sqrt((aht/mut))*((eht*sinh(phit))-phit);
convjt:=deltatd0/86400;

END;
{***************************************************************************}

PROCEDURE ITERATION;

var stock1,shalley,
nrst,norst:real;
var s,m,n,i,j,k,l:integer;

{procedure d'iteration levant les approximations concernant
 les lieux et temps de depart et d'arrivee }


BEGIN

{1ere iteration}

sterre:=datejt;

{calcul de la duree}
duree := datejh - datejt;

ephterj(datejt,mus,0,param,rt,vt);

ephalleyj(datejh,mus,0,ra,va);

CALCUL_RSPHERE_INF(rt,nrt,Rspht,mus,mut);

ELLIPSEJJ(rt,ra,datejt,mjt,datejh,mjh,param,mus,0,cas,vitdepart
      ,vitarrivee,dureecalculee);

VITESSEINFINIE(vt,vitdepart,vitinfT,nvitinfT);

HYPEVASION(deltatd0,Rspht,convjt,mut,rterre,zo);

nSTerre:=sterre+convjt;


REPEAT
      stock1:=convjt;
  
      nrt:=0;
     for s:=1 to 3 do
      begin
      rt[s]:=0;
      vt[s]:=0;
      rst[s]:=0;
      end;
      parking:=nvitinfT;
     
      datejt:=nsterre;

      mjt:=datejt/365250;

      EPHTERJ(datejt,mus,0,param,rt,vt);

      nrt:=norm(rt);
      Rspht:=nrt*exp(ln((mut/mus))*(2/5));

      for m:=1 to 3 do
          begin
          rst[m]:=rt[m]+Rspht*((vitinfT[m])/parking);
          end;

      ELLIPSEJJ(rST,ra,datejt,mjt,datejh,mjh,param,mus,0,cas,vitdepart
      ,vitarrivee,dureecalculee);

      convjt:=0;

      nsterre:=nsterre-stock1;

      VITESSEINFINIE(vt,vitdepart,vitinfT,nvitinfT);

      HYPEVASION(deltatd0,Rspht,convjt,mut,rterre,zo);

      nsterre:=nsterre+convjt;
       
UNTIL (abs(parking-nvitinfT)<0.0001);

END;
{##################################################################}


procedure CALCULS ; 

BEGIN

ITERATION;

   {calcul de la constante C3}
    C3 := sqr(nvitinfT);


END;
{########################################################################}


{***************************************************************************}

{************************PROGRAMME PRINCIPAL********************************}
BEGIN

clrscr;
CALCULS ;

END;
END.