

                       {UNIT...UNIT...UNIT...UNIT}

     UNIT MATRICE;


      {Cette unite rassemble les operations elementaires sur les
       matrices:
            Produit d'un vecteur par une matrice:Y=A*X.
            Produit de deux matrices.
            Produit d'une matrice par un scalaire.
            Transposition.
            Trace.
            Determinant.
            Inverse.}

       INTERFACE

        uses constype;

         procedure prodmatvect(mat:mat33;x:vecteur;var y:vecteur);

         procedure prodmatmat(mat1,mat2:mat33;var mat:mat33);

         procedure transposmat(m:mat33;var mat:mat33);

         procedure prodscalmat(lambda:real;m:mat33;var mat:mat33);

         procedure inversmat(m:mat33;var mat:mat33);

         function trace(m:mat33):real;

         function determinant(m:mat33):real;

       IMPLEMENTATION

         procedure prodmatvect(mat:mat33;x:vecteur;var y:vecteur);

          var i,j:integer;

           BEGIN

            for i:=1 to 3 do
             begin
              y[i]:=0;
              for j:=1 to 3 do
               begin
                y[i]:=y[i]+mat[i,j]*x[j];
               end;
             end;

           END;

         procedure prodmatmat(mat1,mat2:mat33;var mat:mat33);

          var i,j,k:integer;
                  u:mat33;
           BEGIN

             for i:=1 to 3 do
               begin
                 for j:=1 to 3 do
                   begin
                     u[i,j]:=0;
                     for k:=1 to 3 do
                       begin
                         u[i,j]:=u[i,j]+mat1[i,k]*mat2[k,j];
                       end;
                   end;
               end;
               mat:=u;
            END;

        procedure transposmat(m:mat33;var mat:mat33);

         var i,j:integer;

          BEGIN

            for i:=1 to 3 do
              begin
                 for j:=1 to 3 do
                   begin
                     mat[i,j]:=m[j,i];
                   end;
              end;

          END;

      procedure prodscalmat(lambda:real;m:mat33;var mat:mat33);

       var i,j:integer;

        BEGIN

          for i:=1 to 3 do
            begin
              for j:=1 to 3 do
                begin
                  mat[i,j]:=lambda*m[i,j];
                end;
            end;

        END;


      function determinant(m:mat33):real;

       var u,v:real;

       BEGIN

        u:=m[1,1]*m[2,2]*m[3,3]+m[3,1]*m[1,2]*m[2,3]+m[1,3]*m[2,1]*m[3,2];
        v:=m[1,3]*m[2,2]*m[3,1]+m[1,1]*m[3,2]*m[2,3]+m[3,3]*m[2,1]*m[1,2];

        determinant:=u-v;

       END;

      procedure inversmat(m:mat33;var mat:mat33);

        var invers,u:mat33;

         BEGIN

           {Test de non nullite du determinant de la matrice m}

           if (abs(determinant(m))<1e-9)
                 then writeln('erreur:la matrice n est pas inversible');

           {Calcul de transposee de m divisee par det(m)}

           transposmat(m,m);

           {Calcul de la matrice inverse}

           u[1,1]:=m[2,2]*m[3,3]-m[2,3]*m[3,2];
           u[2,2]:=m[3,3]*m[1,1]-m[3,1]*m[1,3];
           u[3,3]:=m[1,1]*m[2,2]-m[1,2]*m[2,1];

           u[1,2]:=-(m[2,1]*m[3,3]-m[3,1]*m[2,3]);
           u[2,3]:=-(m[3,2]*m[1,1]-m[1,2]*m[3,1]);
           u[3,1]:=-(m[1,3]*m[2,2]-m[2,3]*m[1,2]);

           u[2,1]:=-(m[1,2]*m[3,3]-m[3,2]*m[1,3]);
           u[3,2]:=-(m[2,3]*m[1,1]-m[1,3]*m[2,1]);
           u[1,3]:=-(m[3,1]*m[2,2]-m[2,1]*m[3,2]);

           prodscalmat(1/determinant(m),u,mat);
      END;

    function trace(m:mat33):real;

      var i:integer;
          u:real;

        BEGIN

          u:=0;
          for i:=1 to 3 do
            begin
              u:=u+m[i,i];
            end;
          trace:=u;

        END;

   END.
