

                    {UNIT...UNIT...UNIT...UNIT...UNIT}

   UNIT SATURNE;

   {Cette procedure donne les ephemerides de SATURNE compte tenu des
    perturbations dues a JUPITER (periode 883 ans),moyennant les
   precautions suivantes:

        Donner la variable datir sous forme de chaine,par exemple
        le 3 mai 1986 sera note datir='03051986'.

        Donner l'heure sous forme de chaine,par exemple 8h5mn7s
        fournira la variable heure='080507' .

    En sortie le programme fournit les resultats suivants:


          NB:Tous les calculs sur les angles sont operes en radians
             Par contre si vous demandez les resultats imprimes vous
             les aurez en degres(pour cela la variable IMPRIM=1 sinon
             IMPRIM=0).

        Le rayon vecteur de SATURNE dans le repere j 2000 avec comme
        unite le km.
        La vitesse de SATURNE dans j2000,les composantes sont donnees
        en km/s.
        La longitude heliocentrique ecliptique en degres decimaux.
        Le jour julien correspondant a la date

        Les parametres orbitaux de la planete:
            param[1]:demi grand axe en km.
            param[2]:excentricite.
            param[3]:inclinaison en degres.
            param[4]:argument nodal du perihelie.
            param[5]:longitude vernale de la ligne des noeuds en degres.
            param[6]:anomalie excentrique de la position en degres.
            param[7]:date julienne de passage prochain perihelie

        NB:Les calculs internes au programme sont effectues en radian
           et dans le cas d un passage de parametres ceux-ci seront
           transmis en radian,les autres en km ou km/ s.}

    INTERFACE

    uses constype,jourjuli,paramrv,fonscal;


      procedure ephemsaturne(datir,heure:string;mus:real;imprim:integer;
      var param:tabparam;var r,v:vecteur);


    IMPLEMENTATION

      const v1:array[1..5] of real=(0.8740167563,-0.002960036,0.055429643,
                                      -0.008717474,0.019891473);
            v2:array[1..5] of real=(213.5429562,-0.018813138,-0.004477771,
                                      -0.002914183,-0.001633044);
            v3:array[1..5] of real=(9.0673442e-4,0.001283285,-0.003261143,
                                      0.000157351,-0.000223323);
            v4:array[1..5] of real=(-5.57e-8,0.000384811,0.000200072,
                                      0.000012382,0.000011193);
              mm:real=0.0334596521;
              au:real=1.49597893e8;

        procedure ephemsaturne;

         var i:integer;
             par:array[1..5] of real;
             sn2,x,mj,sj,jj2000,jjancien,l,teta,lp,lambda,a,b:real;
             p,q,w:vecteur;

         BEGIN

           datejuli(datir,heure,mj,sj,jj2000,jjancien);

           for i:=1 to 5 do
              begin
               par[i]:=v1[i]+mj*(v2[i]+mj*(v3[i]+mj*v4[i]));
              end;
          {Calcul de a et e compte tenu des perturbations de jupiter}

           b:=3.08686+7.3738*mj;
           a:=9.55490959574-2.139e-5+8.5e-7*sin(b)+5.12e-5*cos(b);

           param[1]:=a*au;
           param[2]:=sqrt(par[2]*par[2]+par[3]*par[3])-1.38e-5*sin(b)
                    +2.34e-5*cos(b);

          {Calcul de l'inclinaison i}

           sn2:=par[4]*par[4]+par[5]*par[5];
           param[3]:=2*arctan(sqrt(sn2/(1-sn2)));

          {Calcul de la longitude du perihelie}

           lp:=arctan(par[3]/par[2]);
           if (par[2]<0) then lp:=lp+pi;
           lp:=lp+(1.361e-3*sin(b)+8.03e-4*cos(b))/param[2];

          {Calcul de la longitude nodale grand omega}

           param[5]:=arctan(par[5]/par[4]);
           if (((par[4]<0) and (par[5]>0)) or ((par[4]<0) and (par[5]<0)))
                    then param[5]:=param[5]+pi
                    else
                         if ((par[5]<0) and (par[4]>0))
                            then param[5]:=2*pi+param[5];

           {Calcul de l argument nodal du perihelie petit omega}

           param[4]:=lp-param[5];
           if( param[4]<0) then param[4]:=param[4]+2*pi;

           {Calcul de l anomalie excentrique fi en radian,valeur comprise
            entre 0 et 2*pi}

           par[1]:=par[1]-0.01421*sin(b)-1.92e-4*cos(b)+1.39e-4*sin(2*b);
           x:=(par[1]-lp)-int((par[1]-lp)/2/pi)*2*pi;
           if (x<0) then x:=x+2*pi;

          {Resolution de l equation transcendante donnant fi}

           for i:=1 to 10 do
             begin
               param[6]:=x+param[2]*sin(param[6]);
             end;

          {Calcul du temps tp de passage suivant au perihelie}

            param[7]:=jj2000+param[1]*sqrt(param[1]/mus)*(2*pi-param[6]
                        +param[2]*sin(param[6]))/86400;

         {Calcul de la latitude heliocentrique et de la longitude
          heliocentrique}

        
         {Calcul grace a la procedure posvitperifocal de la position r,
         de la vitesse v, et des vecteurs p,q,r du repere perifocal.}

           posvitperifocal(mus,param,p,q,w,r,v);

          l:=arctan(r[2]/r[1]);
          if (((r[1]<0) and (r[2]>0)) or ((r[1]<0) and (r[2]<0)))
                    then l:=l+pi
                    else
                         if ((r[2]<0) and (r[1]>0))
                            then l:=2*pi+l;
          lambda:= arctan(r[3]/sqrt((r[1]*r[1]+r[2]*r[2])));

         {Impression des resultats sur demande}

           if (imprim=1) then

             begin
              writeln('***********CARACTERISTIQUES SATURNE*************');
              writeln('      Demi grand axe a=',param[1]/1e6:8:3,' e6 km');writeln;
              writeln('      Excentricite:',param[2]:7:5);writeln;
              writeln('      Inclinaison:',param[3]*180/pi:6:2,' degres');writeln;
              writeln('      Argument nodal du perihelie:',param[4]*180/pi:6:2,
                      ' degres');writeln;
              writeln('      Longitude vernale de la ligne des noeuds',
                      param[5]*180/pi:6:2,' degres');writeln;
              writeln('      Anomalie excentrique:',param[6]*180/pi:6:2,' degres');
                      writeln;
              writeln('      La date du ',datir,' est le jour julien:  ',jj2000:11:5);
              writeln('      Le premier passage au perihelie aura lieu le ',param[7]:11:5,
                       ' jour julien');writeln;
              writeln('      Voici dans le repere j2000 les composantes de:');
              writeln('      Rayon en km: r1=',r[1]/1e6:8:3,' e6 ','r2=',r[2]/1e6:8:3,' e6 ','r3= ',r[3]/1e6:8:3,' e6');
              writeln('      Vitesse en km/s :V1= ',v[1]:7:3,'  V2= ',v[2]:7:3,'  V3= ',v[3]:7:3); writeln;
              writeln('**********************************************');
              writeln('      longitude heliocentrique: ',l*180/pi:6:2,'  degres');
              writeln('      Latitude heliocentrique: ',lambda*180/pi:6:2,'  degres');


              end;
         end;

        end.

   




