

                   {UNIT...UNIT...UNIT...UNIT...UNIT}

   UNIT TROIRAY;

       {Cette procedure resout le probleme de Gibbs:connaissant 3 rayons
       vecteurs independants naturellement coplanaires le programme cal-
       cule le vecteur vitesse pour l'une des positions.
         L'utilisation de l' unite rvparam.pas permet alors de calculer
       coimpletement tous les parametres orbitaux}


    INTERFACE

     uses constype,fonvect;

     procedure troispos(mu:real;x1,x2,x3:vecteur;var v1:vecteur);

    IMPLEMENTATION

     procedure troispos(mu:real;x1,x2,x3:vecteur;var v1:vecteur);

      var result1,result2,result3,n1,n2,n3,d,n,vect3,s,xn,xd:vecteur;
          r1,r2,r3,par,k:real;

       BEGIN
        {Calcul du vecteur D }

         prodvect(x1,x2,result3);
         prodvect(x2,x3,result1);
         prodvect(x3,x1,result2);

         somme(result1,result2,vect3);
         somme(result3,vect3,d);

        {Calcul du vecteur N }

         r1:=norm(x1);
         r2:=norm(x2);
         r3:=norm(x3);

         scalvect(r1,result1,n1);
         scalvect(r2,result2,n2);
         scalvect(r3,result3,n3);

         somme(n1,n2,vect3);
         somme(n3,vect3,n);

        {Calcul du parametre p }
         scalvect(1e-10,d,xd);
         scalvect(1e-10,n,xn);
         par:=norm(xn)/norm(xd);
         
        {Calcul du vecteur s }

         scalvect(r2-r3,x1,result1);
         scalvect(r3-r1,x2,result2);
         scalvect(r1-r2,x3,result3);

         somme(result1,result2,vect3);
         somme(result3,vect3,s);

         {Calcul du vecteur vitesse v1 correspondant a la position 1}

         prodvect(xd,x1,result1);
         k:=sqrt(mu/norm(xn)/norm(xd))*1e-10;
         scalvect(k/norm(x1)*1e10,result1,result2);
         scalvect(k,s,result3);
         somme(result2,result3,v1);

        END;

     END.




