PROGRAM VECTFOND;

{***********************************************
 * Ce programme qui ressemble  vectfond.m sous matlab
 * calcule les vecteurs fondamentaux
 *	h  moment cintique rduit en km/s
 *	e  vecteur excentricit
 *	n  vecteur nodal en km/s
 *  connaissant
 *ro rayon vecteur initial
 *       Vo vitesse initiale
 *  par leurs composantes dans la base gocentrique
 ************************************************}


uses wincrt,windos,fonscal,fonvect,constype;

const mut=39.86e4;

var r,V,e,h,n :vecteur;
    chr:char;

procedure CALCUL_MOMENT_CINETIQUE;
BEGIN

prodvect(r,V,h);

Writeln('   MOMENT CINETIQUE:');
Writeln('          h[1]=h.I= ',h[1]:8:4);
Writeln('          h[2]=h.J= ',h[2]:8:4);
Writeln('          h[3]=h.K= ',h[3]:8:4);
END;

Procedure CALCUL_VECTEUR_EXCENTRICITE;
Var result1,result2,result3,exc:vecteur;
    ex:real;

BEGIN
prodvect(r,V,h);
prodvect(V,h,result1);
scalvect(1/mut,result1,result2);
scalvect(-1/norm(r),r,result3);
somme(result2,result3,exc);
ex:=norm(exc);
Writeln;
Writeln('   VECTEUR EXCENTRICITE:====> excentricit= ',ex:7:5);
Writeln('          e[1]=e.I= ',exc[1]:8:6);
Writeln('          e[2]=e.J= ',exc[2]:8:6);
Writeln('          e[3]=e.K= ',exc[3]:8:6);

END;
procedure CALCUL_VECTEUR_NODAL;
Var K:vecteur;
    inclin:real;

BEGIN
K[1]:=0;K[2]:=0;K[3]:=1;
prodvect(r,V,h);
prodvect(K,h,n);
inclin:=ARCCOS(prodscal(K,h)/norm(h))*180/pi;

Writeln;
Writeln('   VECTEUR NODAL:===> Inclinaison (en degrs)= ',inclin:7:3);
Writeln('          n[1]=n.I= ',n[1]:7:5);
Writeln('          n[2]=n.J= ',n[2]:7:5);
Writeln('          n[3]=n.K= ',n[3]:7:5);
END;



BEGIN

writeln('     Donnez en  km les composantes du rayon vecteur dans I, J, K');
write('          r[1]= ');read(r[1]);
write('          r[2]= ');read(r[2]);
write('          r[3]= ');read(r[3]); writeln;writeln;

writeln('     Donnez en  km/s les composantes du vecteur vitesse dans I, J, K');
write('          V[1]= ');read(V[1]);
write('          V[2]= ');read(V[2]);
write('          V[3]= ');read(V[3]); writeln;writeln;
Writeln('     VOICI LES COMPOSANTES DANS I,J,K DES VECTEURS FONDAMENTAUX');
writeln;

CALCUL_MOMENT_CINETIQUE;
CALCUL_VECTEUR_EXCENTRICITE;
CALCUL_VECTEUR_NODAL;

writeln;writeln;
Writeln('                  ***** NOTEZ VOS RESULTATS *****');Writeln;
Writeln('          ***** POUR QUITTER APPUYEZ SUR UNE TOUCHE ****');
chr:=readkey;

donewincrt;
END.



