

                    {UNIT...UNIT...UNIT...UNIT...UNIT}

   UNIT VENUS;

   {Cette procedure donne les ephemerides de VENUS moyennant les
   precautions suivantes:

        Donner la variable datir sous forme de chaine,par exemple
        le 3 mai 1986 sera note datir='03051986'.

        Donner l'heure sous forme de chaine,par exemple 8h5mn7s
        fournira la variable heure='080507' .

    En sortie le programme fournit les resultats suivants:


          NB:Tous les calculs sur les angles sont operes en radians
             Par contre si vous demandez les resultats imprimes vous
             les aurez en degres(pour cela la variable IMPRIM=1 sinon
             IMPRIM=0).

        Le rayon vecteur de VENUS dans le repere j 2000 avec comme
        unite le km.
        La vitesse de VENUS dans j2000,les composantes sont donnees
        en km/s.
        La longitude heliocentrique ecliptique en degres decimaux.
        Le jour julien correspondant a la date

        Les parametres orbitaux de la planete:
           param[1]:demi grand axe en km.
           param[2]:excentricite.
           param[3]:inclinaison en degres.
           param[4]:argument nodal du perihelie.
           param[5]:longitude vernale de la ligne des noeuds en degres.
           param[6]:anomalie excentrique de la position en degres.
           param[7]:date julienne de passage prochain au perihelie

        NB:Les calculs internes au programme sont effectues en radian
           et dans le cas d un passage de parametres ceux-ci seront
           transmis en radian,les autres en km ou km/ s.}

    INTERFACE

    uses constype,jourjuli,paramrv,fonscal
    ;


      procedure ephemvenus(datir,heure:string;mus:real;imprim:integer;
      var param:tabparam;var r,v:vecteur);


    IMPLEMENTATION

        const v1:array[1..5] of real=(3.176146696,-0.004492821,0.005066847,
                                      0.006824101,0.028822858);
              v2:array[1..5] of real=(10213.52942,0.000923135,-0.001456941,
                                      0.004512949,0.001158456);
              v3:array[1..5] of real=(5.4210556e-4,0.000225036,-0.000048477,
                                      0.000118430,-0.000349720171);
              v4:array[1..5] of real=(2.535e-7,-0.000001441,0.000022573,
                                      0.000017766,0.000008779);
              a:real=0.72332981996;
              mm:real=1.602130476;
              au:real=1.49597893e8;
        procedure ephemvenus;

         var i:integer;
             par:array[1..5] of real;
             sn2,x,mj,sj,jj2000,jjancien,l,teta,lp,lambda:real;
             p,q,w:vecteur;

         BEGIN

           datejuli(datir,heure,mj,sj,jj2000,jjancien);

           for i:=1 to 5 do
              begin
               par[i]:=v1[i]+mj*(v2[i]+mj*(v3[i]+mj*v4[i]));
              end;
          {Calcul de a et e}

           param[1]:=a*au;
           param[2]:=sqrt(par[2]*par[2]+par[3]*par[3]);

          {Calcul de l'inclinaison i}

           sn2:=par[4]*par[4]+par[5]*par[5];
           param[3]:=2*arctan(sqrt(sn2/(1-sn2)));

          {Calcul de la longitude du perihelie}

           lp:=arctan(par[3]/par[2]);
           if (par[2]<0) then lp:=lp+pi;

          {Calcul de la longitude nodale grand omega}

           param[5]:=arctan(par[5]/par[4]);
           if (((par[4]<0) and (par[5]>0)) or ((par[4]<0) and (par[5]<0)))
                    then param[5]:=param[5]+pi
                    else
                         if ((par[5]<0) and (par[4]>0))
                            then param[5]:=2*pi+param[5];

           {Calcul de l argument nodal du perihelie petit omega}

           param[4]:=lp-param[5];
           if( param[4]<0) then param[4]:=param[4]+2*pi;

           {Calcul de l anomalie excentrique fi en radian,valeur comprise
            entre 0 et 2*pi}

           x:=(par[1]-lp)-int((par[1]-lp)/2/pi)*2*pi;
           if (x<0) then x:=x+2*pi;

          {Resolution de l equation transcendante donnant fi}

           for i:=1 to 10 do
             begin
               param[6]:=x+param[2]*sin(param[6]);
             end;

          {Calcul du temps tp de passage suivant au perihelie}

            param[7]:=jj2000+param[1]*sqrt(param[1]/mus)*(2*pi-param[6]
                        +param[2]*sin(param[6]))/86400;

         {Calcul de la latitude heliocentrique et de la longitude
          heliocentrique}

        
         {Calcul grace a la procedure posvitperifocal de la position r,
         de la vitesse v, et des vecteurs p,q,r du repere perifocal.}

           posvitperifocal(mus,param,p,q,w,r,v);

          l:=arctan(r[2]/r[1]);
          if (((r[1]<0) and (r[2]>0)) or ((r[1]<0) and (r[2]<0)))
                    then l:=l+pi
                    else
                         if ((r[2]<0) and (r[1]>0))
                            then l:=2*pi+l;
          lambda:= arctan(r[3]/sqrt((r[1]*r[1]+r[2]*r[2])));

         {Impression des resultats sur demande}

           if (imprim=1) then

             begin
              writeln('***********CARACTERISTIQUES VENUS*************');
              writeln('Demi grand axe a=',param[1],' km');writeln;
              writeln('Excentricite:',param[2]);writeln;
              writeln('Inclinaison:',param[3]*180/pi,' degres');writeln;
              writeln('Argument nodal du perihelie:',param[4]*180/pi,
                      ' degres');writeln;
              writeln('Longitude vernale de la ligne des noeuds',
                      param[5]*180/pi,' degres');writeln;
              writeln('Anomalie excentrique:',param[6]*180/pi,' degres');
                      writeln;
              writeln('La date du ',datir,' est le jour julien:  ',jj2000);
              writeln('Le premier passage au perihelie aura lieu le ',param[7],
                       ' jour julien');writeln;
              writeln('Voici dans le repere j2000 les composantes de:');
              writeln('   Rayon vecteur:',r[1],r[2],r[3]);
              writeln('  Vecteur vitesse:',v[1],v[2],v[3]);
              writeln('**********************************************');
              writeln(' longitude heliocentrique: ',l*180/pi);
              writeln(' Latitude heliocentrique: ',lambda*180/pi);

              end;
         end;

        end.

   




                        